#!/usr/bin/env bash
#
# Soubor: test.sh
# Datum:  24.04.2007
# Autor:  David Martinek, martinek@fit.vutbr.cz
# Popis:  Otestuje sprvnost implementace projektu Rozdl kalendnch dat.
#
# Poznmka: Pokud v tomto skriptu nkterm pkazm nerozumte, pouijte 
#           manulov a info strnky. Uebnice jazyka BASH najdete na webu,
#           nap.: http://www.abclinuxu.cz/clanky/navody/bash-i
#                  http://linuxdoc.linux.cz/LDP/Bash-Beginners-Guide/html/
#                  http://linuxdoc.linux.cz/LDP/abs/html/index.html

# jmno projektu, odvj se od nj i jmno zdrojovho souboru
PROJ=proj2

# Spust program se zadanm parametrem a vsledek vype ve formtovan podob 
# na standardn vstup
# `tyto` uvozovky (na anglick klvesnici vlevo nahoe pod znakem ~) spust text,
# kter se nachz uvnit jako pkaz a ve co program vype na standardn vstup
# se vrt jako textov hodnota
function Run
{
  echo "./$PROJ <<< $1 -> "`./$PROJ <<< $1`
  
# pokud by program etl ze stdin vce dk, mohly by bt testovac hodnoty
# uloeny v pomocnm souboru nebo by je lo zadat takto pmo ve skriptu:
# ./program << __ZNACKA__
# 02.01.2000-01.01.2000
# 02.01.2000-01.01.2123
# 02.01.2888-01.01.2000
# 02.01.2050-01.01.2400
# __ZNACKA__
}

# nastaven programu diff, kter slou pro porovnvn se sprvnmi
# vsledky
DIFFPARAMS="--ignore-blank-lines --ignore-all-space"

# otestuje sprvnost implementace na mnoin vstupnch hodnot
# -- pestupn roky --
function Test1
{
  (
    Run 02.01.2000-01.01.2000
    Run 01.01.2000-01.01.2000
    Run 28.02.2000-28.02.2001
    Run 29.02.2000-28.02.2001
    Run 29.02.2000-01.03.2001
    Run 01.03.2000-28.02.2001
    Run 01.03.2001-29.02.2000
    Run 17.4.1978-8.11.1620
    Run 17.4.1978-15.10.1582
    Run 29.02.2000-29.02.1600
    Run 28.02.2001-01.03.1599
    Run 01.03.2001-28.02.1599
  ) &> $PROJ.test1
  diff $DIFFPARAMS ideal.test1 $PROJ.test1
  if [ $? -gt 0 ]; then
    echo "*** NESHODUJE SE SE VZOROVM EENM ***"
  else
    echo "*** OK ***"
  fi

}

# -- extrmn hodnoty --
function Test2
{
  ( 
    Run 31.12.11000000-15.10.1582
    Run 31.12.11000000-1.1.1
    Run 15.10.1582-31.12.11000000
    Run 17.00004.1978-7.3.24063
  ) &> $PROJ.test2
  diff $DIFFPARAMS ideal.test2 $PROJ.test2
  if [ $? -gt 0 ]; then
    echo "*** NESHODUJE SE SE VZOROVM EENM ***"
  else
    echo "*** OK ***"
  fi 
}

# otestuje reakci programu na chybn zadan vstupn data
function Test3
{
  echo "............. Test a. Chybn formt vstupu ................."
  echo "./$PROJ <<< 01.01.2000+02.01.2000"
  ./$PROJ <<< 01.01.2000+02.01.2000
  echo "................. Test b. Nelegln datumy ................."
  echo "./$PROJ <<< 29.02.2001-29.2.2000"
  ./$PROJ <<< 29.02.2001-29.2.2000
  echo "./$PROJ <<< 01.15.2001-31.4.2000"
  ./$PROJ <<< 01.15.2001-31.04.2000 
  echo "*** konec testu ***"
}

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# start programu
echo "Spoutm test. Vsledek najdete v souboru test.log"
# kulat zvorky znamenaj vnoen shell - ve, co uvnit nich vytisknu,
# mu pesmrovat do souboru
(
  echo "Vsledek testovacho skriptu"
  # existuje soubor ./proj2 a je spustiteln?
  if [ -x $PROJ ]; then
    # Nastav limit bhu programu na 15 vtein, kdyby se nco zacyklilo,
    # bude program po tto dob zabit.
    ulimit -t 15
    echo "------------------ Test pestupnch let --------------------"
    Test1
    echo "---------------- Test na extrmn hodnoty ------------------"
    Test2
    echo "--------------- Test reakce na chybn vstup ----------------"
    Test3
  else
    echo "*** CHYBA, ./$PROJ neexistuje! ***"
  fi
) &> test.log 
# konec souboru test.sh

